/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.cosmodas.FacadeCosmos;

import com.cosmodas.EntCosmos.DetalleFactura;
import com.cosmodas.EntCosmos.Facturas;
import com.cosmodas.EntCosmos.FacturasPK;

import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

/**
 * @author obper
 */
@Stateless
public class FacturasFacade extends AbstractFacade<Facturas> implements FacturasFacadeLocal {

    @PersistenceContext(unitName = "wcosmodasPersistent")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public FacturasFacade() {
        super(Facturas.class);
    }

    @Override
    public Facturas BusquedaFactura(String codigoFactura, String facturaSerie) {
        Facturas rs = new Facturas();

        Query q = em.createNativeQuery("Select * from facturas where factura_codigo = ? and factura_serie = ?", Facturas.class);
        q.setParameter(1, codigoFactura);
        q.setParameter(2, facturaSerie);

        if(q.getResultList().isEmpty()){
             q = em.createNativeQuery("Select * from hfacturas where factura_codigo = ? and factura_serie = ?", Facturas.class);
            q.setParameter(1, codigoFactura);
            q.setParameter(2, facturaSerie);


        }
        rs = (Facturas) q.getResultList().get(0);

        return rs;
    }

    @Override
    public Facturas busquedaHFacturas(String facturaCodigo, String facturaSerie) {

        Facturas lsR = (Facturas) em.createNativeQuery("{CALL hfacts(?,?)}",
                        Facturas.class)
                .setParameter(1, facturaCodigo)
                .setParameter(2, facturaSerie).getResultList().get(0);
        return lsR;

    }

    @Override
    public List<DetalleFactura> busquedaHdetFacturas(String facturaCodigo, String facturaSerie) {

        List<DetalleFactura> lsR = (List<DetalleFactura>) em.createNativeQuery("{CALL hdetfacts(?,?)}",
                        DetalleFactura.class)
                .setParameter(1, facturaCodigo)
                .setParameter(2, facturaSerie).getResultList();
        return lsR;

    }

    @Override
    public void actualizaImpresoFactura(String facturaCodigo, String facturaSerie) {
        StringBuilder sql = new StringBuilder("update facturas set factura_impresa = 1 where factura_codigo = ? and factura_serie = ?");
        Query q = em.createNativeQuery(sql.toString());
        q.setParameter(1, facturaCodigo);
        q.setParameter(2, facturaSerie);
        q.executeUpdate();


    }

    @Override
    public void consultorMasivo(String consultorCodigo) {

        Query q = em.createNativeQuery("update consultores_datos set consultor_masivo = 1 where consultor_codigo = ?");
        q.setParameter(1, consultorCodigo);
        q.executeUpdate();
    }


}
